package mop.impl;

import java.io.StringReader;

import javax.xml.parsers.DocumentBuilder;
import javax.xml.parsers.DocumentBuilderFactory;

import mop.pipe.DocumentSource;
import mop.pipe.ChannelException;

import org.w3c.dom.Document;
import org.xml.sax.InputSource;

/**
 * Seplice implementazione di una "source XML". Ritorna un semplice documento xml:
 * <p>
 * &lt;saluto&gt;Hello world!&lt;/saluto&gt;
 */
public class SampleSource implements DocumentSource {

    /**
     * Documento XML
     */
    public static final String XML_DOCUMENT = "<saluto>Hello world!</saluto>";

    /**
     *  Default constructor
     */
    public SampleSource() {
    }

    /**
     * Produttore documento
     * 
     * @return documento XML in formato DOM
     */
    public Document createDocument() throws ChannelException {
        try {
            DocumentBuilder documentBuilder = DocumentBuilderFactory.newInstance().newDocumentBuilder();
            Document document = documentBuilder.parse(new InputSource(new StringReader(XML_DOCUMENT)));
            return document;
        } catch (Exception ex) {
            throw new ChannelException("Exeption in parse document: " + ex.getMessage(), ex);
        }
    }

}