package mop.pipe;

import java.util.HashMap;
import java.util.Map;


/**
 * Factory interfaccia channel. Ritorna un "canale" per l'elaborazione di messaggi
 * DOM-XML. Il canale viene identificato da un nome. Se il canale non esiste lo crea. 
 */
public class ChannelFactory {

	/**
	 * Collezione di canali
	 */
	private static Map moms = new HashMap();

	/**
	 * Default constructor
	 */
	private ChannelFactory() {
	}

	/**
	 * Ritorna un istanza di "Channel". L'istanza deve essere identificata da un nome.
	 * 
	 * @param name nome istanza channel
	 * @param create se vero crea una nuova oggetto "Channel" se non esiste
	 * @return oggetto "Channel"
	 */
	public static Channel getChannel(String name, boolean create) {
	    Channel result = (Channel) moms.get(name);
		if ((result == null) && (create)) {
			result = new SimpleChannel(name);
			moms.put(name,result);
		}
		return result;
	}

}