package mop.pipe;

import java.util.EventObject;
import org.w3c.dom.Document;

/**
 * Semplice evento per il traspoto di un document XML in formato DOM
 */
public class DocumentEvent extends EventObject {

    /**
     * Documento XML in DOM
     */
    private Document document;
	

    /**
     * Constructor
     * 
     * @param source l'oggetto che ha originato l'evento
     * @param document documento XML in DOM da analizzare
     */
    public DocumentEvent(Object source, Document document ) {
		super(source);
		this.document = document;
	}
	
    /**
     * Documento XML in DOM da analizzare
     * 
     * @return Documento XML in DOM da analizzare
     */
	public Document getDocument() {
		return document;
	}
}
