package mop.pipe;

import java.util.ArrayList;
import java.util.Iterator;
import java.util.List;


/**
 * Semplice canale di comunicazione per componenti elaborazione DOM-XML.
 */
public class SimpleChannel implements Channel {

	private DocumentSource source;
	private List listeners;
	private String name;
	
	public SimpleChannel( String name ) {
		listeners = new ArrayList();
	}
	
	public String getName() {
		return name;
	}

	public void setSource(DocumentSource source) {
		this.source = source;
	}

	public void addListener( DocumentListener listener ) {
		listeners.add(listener);
	}
	
	public void removeListener( DocumentListener listener ) {
		listeners.remove(listener);
	}
	
	public void process() throws ChannelException {
		process( new DocumentEvent( source, source.createDocument() ) );
	}

	public void process( DocumentEvent event ) throws ChannelException {
		for( Iterator i = listeners.iterator(); i.hasNext(); ) {
			DocumentListener listener = (DocumentListener)i.next();
			listener.onDocument( event );
		}
	}
	
}
